searchData={"content_type":"text/markdown","items":[{"doc":"Invokes `node` with the provided arguments.\n\n> #","ref":"Mix.Tasks.Nodelix.html","title":"mix nodelix","type":"task"},{"doc":">\n> This is a pre-release version. As such, anything _may_ change at any time, the public\n> API _should not_ be considered stable, and using a pinned version is _recommended_.\n\nUsage:\n\n    $ mix nodelix TASK_OPTIONS NODE_ARGS\n\nExample:\n\n    $ mix nodelix some-script.js --some-option\n\nRefer to `Nodelix` for more information on configuration and profiles.","ref":"Mix.Tasks.Nodelix.html#module-warning-warning","title":"Warning {: .warning} - mix nodelix","type":"task"},{"doc":"- `--profile` - name of the profile to use\n\n  - `--runtime-config` - load the runtime configuration\n    before executing command\n\nFlags to control this Mix task must be given before the\nnode arguments:\n\n    $ mix nodelix --profile default --runtime-config some-script.js --some-option","ref":"Mix.Tasks.Nodelix.html#module-options","title":"Options - mix nodelix","type":"task"},{"doc":"Installs Node.js.\n\n> #","ref":"Mix.Tasks.Nodelix.Install.html","title":"mix nodelix.install","type":"task"},{"doc":">\n> This is a pre-release version. As such, anything _may_ change at any time, the public\n> API _should not_ be considered stable, and using a pinned version is _recommended_.\n\n    $ mix nodelix.install\n    $ mix nodelix.install --force\n\nBy default, it installs 20.10.0 but you\ncan configure it in your config files, such as:\n\n    config :nodelix, :version, \"20.10.0\"","ref":"Mix.Tasks.Nodelix.Install.html#module-warning-warning","title":"Warning {: .warning} - mix nodelix.install","type":"task"},{"doc":"- `--runtime-config` - load the runtime configuration\n    before executing command\n\n  - `--force` - install even if the given version is already present","ref":"Mix.Tasks.Nodelix.Install.html#module-options","title":"Options - mix nodelix.install","type":"task"},{"doc":"Invokes `npm` with the provided arguments.\n\n> #","ref":"Mix.Tasks.Nodelix.Npm.html","title":"mix nodelix.npm","type":"task"},{"doc":">\n> This is a pre-release version. As such, anything _may_ change at any time, the public\n> API _should not_ be considered stable, and using a pinned version is _recommended_.\n\nUsage:\n\n    $ mix nodelix.npm TASK_OPTIONS NODE_ARGS\n\nExample:\n\n    $ mix nodelix.npm install --save-dev semantic-release semantic-release-hex\n\nRefer to `Mix.Tasks.Nodelix` for task options and to `Nodelix` for more information\non configuration and profiles.","ref":"Mix.Tasks.Nodelix.Npm.html#module-warning-warning","title":"Warning {: .warning} - mix nodelix.npm","type":"task"},{"doc":"Nodelix is an installer and runner for [Node.js](https://nodejs.org/).\n\n> #","ref":"Nodelix.html","title":"Nodelix","type":"module"},{"doc":">\n> This is a pre-release version. As such, anything _may_ change at any time, the public\n> API _should not_ be considered stable, and using a pinned version is _recommended_.","ref":"Nodelix.html#module-warning-warning","title":"Warning {: .warning} - Nodelix","type":"module"},{"doc":"There are two global configurations for the nodelix application:\n\n- `:version` - the Node.js version to use\n\n- `:cacerts_path` - the directory to find certificates for\n    https connections","ref":"Nodelix.html#module-nodelix-configuration","title":"Nodelix configuration - Nodelix","type":"module"},{"doc":"You can define multiple nodelix profiles. There is a default empty profile\nwhich you can configure its args, current directory and environment:\n\n```elixir\nconfig :nodelix,\nversion: \"20.10.0\",\ndefault: [\n  args: ~w(\n    some-script.js\n    --some-option\n  ),\n  cd: Path.expand(\"../assets\", __DIR__),\n],\ncustom: [\n  args: ~w(\n    another-script.js\n    --another-option\n  ),\n  cd: Path.expand(\"../assets/scripts\", __DIR__),\n]\n```\n\nThe default current directory is your project's root.\n\nTo use a profile other than `default`, you can use\nthe `--profile` option:\n\n```shell\nmix nodelix --profile custom\n```\n\nWhen `mix nodelix` is invoked, the task arguments will\nbe appended to the ones configured in the profile.","ref":"Nodelix.html#module-profiles","title":"Profiles - Nodelix","type":"module"},{"doc":"Returns the configuration for the given profile.\n\nRaises if the profile does not exist.","ref":"Nodelix.html#config_for!/1","title":"Nodelix.config_for!/1","type":"function"},{"doc":"Returns the configured Node.js version.","ref":"Nodelix.html#configured_version/0","title":"Nodelix.configured_version/0","type":"function"},{"doc":"Installs Node.js if the configured version is not available,\nand then runs `node`.\n\nReturns the same as `run/2`.","ref":"Nodelix.html#install_and_run/2","title":"Nodelix.install_and_run/2","type":"function"},{"doc":"Runs the given command with `args`.\n\nThe given args will be appended to the configured args.\nThe task output will be streamed directly to stdio. It\nreturns the status of the underlying call.","ref":"Nodelix.html#run/2","title":"Nodelix.run/2","type":"function"},{"doc":"# Nodelix\n\nSeamless Node.js in Elixir.\n\n> **⚠️ WARNING**\n>\n> This is a pre-release version. As such, anything _may_ change\n> at any time, the public API _should not_ be considered stable,\n> and using a pinned version is _recommended_.\n\nProvides Mix tasks for the installation and execution of Node.js.\n\nThis project is currently not recommended for production Elixir use.\nIts main purpose is to offer a straightforward interface for utilizing Node.js and npm libraries within Mix tasks.\n\nFull documentation can be found at [https://hexdocs.pm/nodelix](https://hexdocs.pm/nodelix).","ref":"readme.html","title":"Nodelix","type":"extras"},{"doc":"`gpg` must be available in your PATH to verify the signature of Node.js releases.\n\nThe package can be installed by adding `nodelix` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:nodelix, \"1.0.0-alpha.8\", only: :dev, runtime: false}\n  ]\nend\n```\n\nOnce installed, change your `config/config.exs` to pick your\nNode.js version of choice:\n\n```elixir\nconfig :nodelix, version: \"20.10.0\"\n```\n\nNow you can install Node.js by running:\n\n```shell\n$ mix nodelix.install\n```\n\nAnd invoke Node.js with:\n\n```shell\n$ mix nodelix some-script.js --some-option\n```\n\nThe Node.js installation is located at `_build/dev/nodejs/versions/$VERSION`.","ref":"readme.html#installation","title":"Installation - Nodelix","type":"extras"},{"doc":"There are two global configurations for the nodelix application:\n\n- `:version` - the Node.js version to use\n\n- `:cacerts_path` - the directory to find certificates for\n  https connections","ref":"readme.html#nodelix-configuration","title":"Nodelix configuration - Nodelix","type":"extras"},{"doc":"You can define multiple nodelix profiles. There is a default empty profile\nwhich you can configure its args, current directory and environment:\n\n```elixir\nconfig :nodelix,\n  version: \"20.10.0\",\n  default: [\n    args: ~w(\n      some-script.js\n      --some-option\n    ),\n    cd: Path.expand(\"../assets\", __DIR__)\n  ],\n  custom: [\n    args: ~w(\n      another-script.js\n      --another-option\n    ),\n    cd: Path.expand(\"../assets/scripts\", __DIR__),\n    env: [\n      NODE_DEBUG: \"*\"\n    ]\n  ]\n```\n\nThe default current directory is your project's root.\n\nTo use a profile other than `default`, you can use the `--profile` option:\n\n```shell\nmix nodelix --profile custom\n```\n\nWhen `mix nodelix` is invoked, the task arguments will\nbe appended to the ones configured in the profile.","ref":"readme.html#profiles","title":"Profiles - Nodelix","type":"extras"},{"doc":"This project follows the principles of [Semantic Versioning (SemVer)](https://semver.org/).","ref":"readme.html#versioning","title":"Versioning - Nodelix","type":"extras"},{"doc":"Based on the code from [`tailwind`](https://github.com/phoenixframework/tailwind) (v0.2.2).\nFor licensing and copyright details, refer to the [`LICENSE` file](./LICENSE.md).","ref":"readme.html#credits","title":"Credits - Nodelix","type":"extras"},{"doc":"# Changelog\n\n## [1.0.0-alpha.8](https://github.com/sheerlox/nodelix/compare/v1.0.0-alpha.7...v1.0.0-alpha.8) (2023-11-30)\n\n\n#","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"* `--if-missing` is now the default, use `--force` to reinstall an existing version\n\n#","ref":"changelog.html#breaking-changes","title":"⚠ Breaking changes - Changelog","type":"extras"},{"doc":"* don't reinstall by default & add force install flag ([0bb58d0](https://github.com/sheerlox/nodelix/commit/0bb58d06b77db15a2b3da66bf6cd4de18f5cded2))\n\n## [1.0.0-alpha.7](https://github.com/sheerlox/nodelix/compare/v1.0.0-alpha.6...v1.0.0-alpha.7) (2023-11-29)\n\n\n#","ref":"changelog.html#features","title":"✨ Features - Changelog","type":"extras"},{"doc":"* the profile is no longer the first argument of `mix nodelix`\n\n#","ref":"changelog.html#breaking-changes","title":"⚠ Breaking changes - Changelog","type":"extras"},{"doc":"* add `mix nodelix.npm` task ([8f3b22c](https://github.com/sheerlox/nodelix/commit/8f3b22c46ea5c79b3a1e9d817d66f81ebeca2f31))\n* make profile a task option ([47d05ed](https://github.com/sheerlox/nodelix/commit/47d05ed813bf5893ffabf56c93a7e80bfa8a9383))\n\n## [1.0.0-alpha.6](https://github.com/sheerlox/nodelix/compare/v1.0.0-alpha.5...v1.0.0-alpha.6) (2023-11-29)\n\n\n#","ref":"changelog.html#features","title":"✨ Features - Changelog","type":"extras"},{"doc":"* **deps:** update dependency gpg_ex to v1.0.0-alpha.4 ([3e1353f](https://github.com/sheerlox/nodelix/commit/3e1353f6ff443ec427651d49402a8e98073b1e37))\n\n## [1.0.0-alpha.5](https://github.com/sheerlox/nodelix/compare/v1.0.0-alpha.4...v1.0.0-alpha.5) (2023-11-28)\n\n\n#","ref":"changelog.html#builds","title":"🛠 Builds - Changelog","type":"extras"},{"doc":"* update dependency semantic-release-hex to v1.1.1 ([df783d9](https://github.com/sheerlox/nodelix/commit/df783d9fb2b2fdb5cbb42ce35597c85ecfd6c795))\n\n\n#","ref":"changelog.html#builds","title":"🛠 Builds - Changelog","type":"extras"},{"doc":"* update semantic-release config ([06e13e0](https://github.com/sheerlox/nodelix/commit/06e13e078d30b0ff639c0be7b403d36fae5f4981))\n\nChangelog\n\n## [1.0.0-alpha.4](https://github.com/sheerlox/nodelix/compare/v1.0.0-alpha.3...v1.0.0-alpha.4) (2023-11-28)\n\n\n#","ref":"changelog.html#continuous-integrations","title":"⚙️ Continuous Integrations - Changelog","type":"extras"},{"doc":"* add Node.js `VersionManager` module & Mix tasks ([#1](https://github.com/sheerlox/nodelix/issues/1)) ([cc5d14d](https://github.com/sheerlox/nodelix/commit/cc5d14d678a8db3fa130398efc340648d741d376))\n\n# Changelog\n\n## [1.0.0-alpha.3](https://github.com/sheerlox/nodelix/compare/v1.0.0-alpha.2...v1.0.0-alpha.3) (2023-11-24)\n\n\n#","ref":"changelog.html#features","title":"✨ Features - Changelog","type":"extras"},{"doc":"* **readme:** add do not use warning ([1db5348](https://github.com/sheerlox/nodelix/commit/1db53484ccab2d5192b382a6be8d61b629405aa4))\n\n\n#","ref":"changelog.html#documentation","title":"📚 Documentation - Changelog","type":"extras"},{"doc":"* handle hex publishing in semantic-release ([aeeba12](https://github.com/sheerlox/nodelix/commit/aeeba12e4bb16ff8b555188572214ed3f6e03575))\n* unpublish next version if release fails ([9ca1f44](https://github.com/sheerlox/nodelix/commit/9ca1f44a10afc2ea16cfbe80af80ca08afeffe39))\n\n## [1.0.0-alpha.2](https://github.com/sheerlox/nodelix/compare/v1.0.0-alpha.1...v1.0.0-alpha.2) (2023-11-22)\n\n\n#","ref":"changelog.html#continuous-integrations","title":"⚙️ Continuous Integrations - Changelog","type":"extras"},{"doc":"* **hex:** add main field to docs configuration ([85324c1](https://github.com/sheerlox/nodelix/commit/85324c1d1b99c2a2a22a68d24221863b5b1515ad))\n\n\n#","ref":"changelog.html#builds","title":"🛠 Builds - Changelog","type":"extras"},{"doc":"* add test & release workflows ([afa22e1](https://github.com/sheerlox/nodelix/commit/afa22e1695fabdcbd3e270604ddba09bd28aab28))\n\n\n#","ref":"changelog.html#continuous-integrations","title":"⚙️ Continuous Integrations - Changelog","type":"extras"},{"doc":"* **deps:** update dependency semantic-release-hex to v1.1.0 ([21ac76c](https://github.com/sheerlox/nodelix/commit/21ac76c299d185fa7ba45bdac5e51e49804be5f0))","ref":"changelog.html#chores","title":"♻️ Chores - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#1-0-0-alpha-1-2023-11-22","title":"1.0.0-alpha.1 (2023-11-22) - Changelog","type":"extras"},{"doc":"* **hex:** add package metadata ([3f773a3](https://github.com/sheerlox/nodelix/commit/3f773a37493fe80ea4b35770588ce3246a42f5af))\n\n\n#","ref":"changelog.html#builds","title":"🛠 Builds - Changelog","type":"extras"},{"doc":"* setup ex_doc ([1de8541](https://github.com/sheerlox/nodelix/commit/1de8541a7a9a743fcaa6dd9277c89e1aa8981b13))\n\n\n#","ref":"changelog.html#documentation","title":"📚 Documentation - Changelog","type":"extras"},{"doc":"* setup semantic-release ([29815b7](https://github.com/sheerlox/nodelix/commit/29815b7421f1357338f8a405ed28ad5ebea02359))\n\n\n#","ref":"changelog.html#continuous-integrations","title":"⚙️ Continuous Integrations - Changelog","type":"extras"},{"doc":"* add license file ([8bf963d](https://github.com/sheerlox/nodelix/commit/8bf963dd4d7f514aaa23ff96110cd42f5c12c82b))\n* initialize project ([f8fc53a](https://github.com/sheerlox/nodelix/commit/f8fc53abd2c81f9ee2854faf0b86d824b56bbe69))","ref":"changelog.html#chores","title":"♻️ Chores - Changelog","type":"extras"},{"doc":"# Licenses\n\n## `nodelix` (Apache-2.0)\n\nCopyright (c) 2023 Pierre Cavin\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.\n\n## `tailwind` (MIT)\n\nCopyright (c) 2022 Chris McCord.\nCopyright (c) 2021 Wojtek Mach, José Valim.\n\nPermission is hereby granted, free of charge, to any person obtaining\na copy of this software and associated documentation files (the\n\"Software\"), to deal in the Software without restriction, including\nwithout limitation the rights to use, copy, modify, merge, publish,\ndistribute, sublicense, and/or sell copies of the Software, and to\npermit persons to whom the Software is furnished to do so, subject to\nthe following conditions:\n\nThe above copyright notice and this permission notice shall be\nincluded in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\nEXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\nMERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND\nNONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE\nLIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION\nOF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION\nWITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"Licenses","type":"extras"}]}